//all by me (*xd*) :)

COM_AddCommand("EscapeClock", function(player, arg1)
    if arg1 == nil
        CONS_Printf(player, 'you can enable and disable the escape clock.')
        return
    end

    if arg1 == "1" or arg1 == "yes" or arg1 == "enable" then
        player.escapeclocks = 1
    elseif arg1 == "0" or arg1 == "no" or arg1 == "disable" then
        player.escapeclocks = 0
    end
end)

COM_AddCommand("EscapeClock_type", function(player, arg1)
    if arg1 == nil
        CONS_Printf(player, 'you can change the type of escapeclock (two variables: sugary and pizza).')
        return
    end

    if arg1 == "1" or arg1 == "pizza" then
        player.escapeclockstype = 1
    elseif arg1 == "2" or arg1 == "sugary" then
        player.escapeclockstype = 2
    end
end)

freeslot("S_PANICCLOCK","S_PANICCLOCK_COLLECT","S_PANICCLOCK_SOUND","SPR_ESCK","sfx_escclk")
states[S_PANICCLOCK] = {SPR_ESCK,FF_ANIMATE,-1,nil,J,2,S_PANICCLOCK}
states[S_PANICCLOCK_COLLECT] = {SPR_ESCK,A|FF_ANIMATE,3,nil,A,2,S_PANICCLOCK_SOUND}
states[S_PANICCLOCK_SOUND] = {SPR_NULL,0,16,nil,0,0,S_NULL}
sfxinfo[sfx_escclk].caption = "clock"

local function PT_PanicClock(mo)
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == nil
	and ((displayplayer.escapeclockstype == nil)
	or (displayplayer.escapeclockstype == 1))
	
	or displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == 1
	and ((displayplayer.escapeclockstype == nil)
	or (displayplayer.escapeclockstype == 1))
		if mo.health
			if mo.state != S_PANICCLOCK
				mo.state = S_PANICCLOCK
			end
		elseif mo.state != S_PANICCLOCK_COLLECT
		and mo.state != S_PANICCLOCK_SOUND
			mo.state = S_PANICCLOCK_COLLECT
		end
	else
		if mo.health
			if mo.state == S_PANICCLOCK
				mo.state = mo.info.spawnstate
			end
		elseif mo.state == S_PANICCLOCK_COLLECT
		or mo.state == S_PANICCLOCK_SOUND
			mo.state = mo.info.deathstate
		end
	end
end
addHook("MobjThinker",PT_PanicClock,MT_RING)
addHook("MobjThinker",PT_PanicClock,MT_COIN)

local function ReplaceFlings(mo)
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == nil
	and ((displayplayer.escapeclockstype == nil)
	or (displayplayer.escapeclockstype == 1))
	
	or displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == 1
	and ((displayplayer.escapeclockstype == nil)
	or (displayplayer.escapeclockstype == 1))
		if mo.state != S_PANICCLOCK
		and mo.health
			mo.state = S_PANICCLOCK
		end
	elseif mo.state == S_PANICCLOCK
	and mo.health
		mo.state = mo.info.spawnstate
	end
end
addHook("MobjSpawn",ReplaceFlings,MT_FLINGRING)
addHook("MobjSpawn",ReplaceFlings,MT_FLINGCOIN)

local function PanicClock(mo,mobj) 
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == nil
	and ((displayplayer.escapeclockstype == nil)
	or (displayplayer.escapeclockstype == 1))
	
	or displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == 1
	and ((displayplayer.escapeclockstype == nil)
	or (displayplayer.escapeclockstype == 1))
		S_StopSound(mo)
		S_StartSoundAtVolume(mo,sfx_escclk,255)
	end
end
addHook("MobjDeath",PanicClock,MT_RING)
addHook("MobjDeath",PanicClock,MT_COIN)
addHook("MobjDeath",PanicClock,MT_FLINGRING)
addHook("MobjDeath",PanicClock,MT_FLINGCOIN)

//
//escape candys from SS
//

freeslot("S_ESCAPECANDY","S_ESCAPECANDY_COLLECT","S_ESCAPECANDY_SOUND","SPR_CNDE","sfx_colesc")
states[S_ESCAPECANDY] = {SPR_CNDE,FF_ANIMATE,-1,nil,P,3,S_ESCAPECANDY}
states[S_ESCAPECANDY_COLLECT] = {SPR_CNDE,A|FF_ANIMATE,8,nil,D,2,S_ESCAPECANDY_SOUND}
states[S_ESCAPECANDY_SOUND] = {SPR_NULL,0,16,nil,0,0,S_NULL}
sfxinfo[sfx_colesc].caption = "Candy Collect"

local function EscapeCandy(mo)
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == 1
	and displayplayer.escapeclockstype == 2
	
	or displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == nil
	and displayplayer.escapeclockstype == 2
		if mo.health
			if mo.state != S_ESCAPECANDY
				mo.state = S_ESCAPECANDY
			end
		elseif mo.state != S_ESCAPECANDY_COLLECT
		and mo.state != S_ESCAPECANDY_SOUND
			mo.state = S_ESCAPECANDY_COLLECT
		end
	else
		if mo.health
			if mo.state == S_ESCAPECANDY
				mo.state = mo.info.spawnstate
			end
		elseif mo.state == S_ESCAPECANDY_COLLECT
		or mo.state == S_ESCAPECANDY_SOUND
			mo.state = mo.info.deathstate
		end
	end
end
addHook("MobjThinker",EscapeCandy,MT_RING)
addHook("MobjThinker",EscapeCandy,MT_COIN)

local function PZNO_ReplaceFlings(mo)
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == 1
	and displayplayer.escapeclockstype == 2
	
	or displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == nil
	and displayplayer.escapeclockstype == 2
		if mo.state != S_ESCAPECANDY
		and mo.health
			mo.state = S_ESCAPECANDY
		end
	elseif mo.state == S_ESCAPECANDY
	and mo.health
		mo.state = mo.info.spawnstate
	end
end
addHook("MobjSpawn",PZNO_ReplaceFlings,MT_FLINGRING)
addHook("MobjSpawn",PZNO_ReplaceFlings,MT_FLINGCOIN)

local function PZ_CandyCollect(mo,mobj) 
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == 1
	and displayplayer.escapeclockstype == 2
	
	or displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and (PTSR and PTSR.pizzatime)
	and displayplayer.escapeclocks == nil
	and displayplayer.escapeclockstype == 2
		S_StopSound(mo)
		S_StartSound(mo,sfx_colesc)
	end
end
addHook("MobjDeath",PZ_CandyCollect,MT_RING)
addHook("MobjDeath",PZ_CandyCollect,MT_COIN)
addHook("MobjDeath",PZ_CandyCollect,MT_FLINGRING)
addHook("MobjDeath",PZ_CandyCollect,MT_FLINGCOIN)